// here are the animations I have included in my show
// there are not a lot of comments here about individual animations,
// but the subroutines in the next tab are very well documented
// if you are interested in trying to create you own animations


void spheres() {
  for (int offset = 0; offset < 23; offset++) {
    for (int k = 0; k < 9; k++) {
      for (int j = 0; j < 12; j++) {
        for (int i = 0; i < 12; i++) {
          if (pgm_read_word_near(&sphere[k][11 - j]) & (1 << i)) {
            int newCol = i + offset; if (newCol > 24) newCol -= 24; 
            int newCol2 = i - offset; if (newCol2 < 0) newCol2 += 24; 
            setHue(j, newCol, myhue);
            setHue(j, 23 - newCol2,  myhue);
          }
        }
      }
      myhue += 5;
      showClear(25);
    }
    for (int k = 8; k > -1; k--) {
      for (int j = 0; j < 12; j++) {
        for (int i = 0; i < 12; i++) {

          if (pgm_read_word_near(&sphere[k][11 - j]) & (1 << i)) {
           int newCol = i + offset; if (newCol > 24) newCol -= 24; 
            int newCol2 = i - offset; if (newCol2 < 0) newCol2 += 24; 
            setHue(j, newCol, myhue);
            setHue(j, 23 - newCol2,  myhue);
          }
        }
      }
      myhue += 5;
      showClear(25);
    }
  }
  pause();
}


void sinewave() {
  brightness(40);
  for (int k = 1; k < 13; k++) {
    for (int j = 0; j < 12; j++) {
      for (int i = 0; i < 12; i++) {
        if (pgm_read_word_near(&plane[k][11 - j]) & (1 << i)) {
          setStd(j, i, Blue);
          setStd(j, 23 - i, Blue);
        }
      }
    }
    for (int i = 0; i < 23; i++) {
      for (int m = 0; m < 12; m++) {
        rotate(m, 1);
      }
      showKeep(30 + k / 2);
    }
    clearAll();
  }
  float adj = 3.8;
  brightness(50);
  for (int count = 0; count < 15; count++) {
    for (int i = 0; i < 40; i++) {
      for (byte xx = 0; xx < 24; xx++) {
        byte z = ((byte)(6 + cos((xx / adj) + (float)i / 6.28) * 6)); // the actual z calculation
        if (z<12) setStd(z, xx, Blue); // put z into the proper place for each position in quadrant 1
      }
      showClear(5);
    }
    adj -= .2;
    if (adj < 1.9)adj = 1.9;
  }
  for (int count = 0; count < 12; count++) {
    for (int i = 0; i < 40; i++) {
      for (byte xx = 0; xx < 24; xx++) {
        byte z = ((byte)(6 + cos((xx / adj) + (float)i / 6.28) * 6)); // the actual z calculation
        if (z<12)setStd(z, xx, Blue); // put z into the proper place for each position in quadrant 1
      }
      showClear(5);
    }
    adj += .2;
    if (adj > 3.8)adj = 3.8;
  }
  brightness(40);
  for (int k = 12; k > 0; k--) {
    for (int j = 0; j < 12; j++) {
      for (int i = 0; i < 12; i++) {
        if (pgm_read_word_near(&plane[k][11 - j]) & (1 << i)) {
          setStd(j, i, Blue);
          setStd(j, 23 - i, Blue);
        }
      }
    }
    for (int i = 0; i < 23; i++) {
      for (int m = 0; m < 12; m++) {
        rotate(m, 1);
      }
      showKeep(30 + k / 2);
    }
    clearAll();
  }
  brightness(25);
  pause();
}


void shadowMotion() {
  myhue = 0;
  fillTower(myhue);
  for (int count = 0; count < 2; count++) {
    for (int k = 1; k < 13; k++) {
      for (int j = 0; j < 12; j++) {
        for (int i = 0; i < 12; i++) {
          if (pgm_read_word_near(&plane[k][11 - j]) & (1 << i)) {
            setStd(j, i, Blue);
            setStd(j, 23 - i, Blue);
          }
        }
      }
      for (int i = 0; i < 23; i++) {
        for (int m = 0; m < 12; m++) {
          rotate(m, 0); // clockwise
        }
        showKeep(10 + k / 2);
      }
      fillTower(myhue);
      myhue += 1;
    }
    for (int k = 11; k > 1; k--) {
      for (int j = 0; j < 12; j++) {
        for (int i = 0; i < 12; i++) {
          if (pgm_read_word_near(&plane[k][11 - j]) & (1 << i)) {
            setStd(j, i, Blue);
            setStd(j, 23 - i, Blue);
          }
        }
      }
      for (int i = 0; i < 23; i++) {
        for (int m = 0; m < 12; m++) {
          rotate(m, 0); // clockwise
        }
        showKeep(10 + k / 2);
      }
      fillTower(myhue);
      myhue += 1;
    }
  }
 for (int count = 0; count < 15; count++) {
    for (int i = 0; i < 40; i++) {
      for (byte xx = 0; xx < 24; xx++) {
        byte z = ((byte)(6 + cos((xx / 1.9) + (float)i / 6.28) * 6)); // the actual z calculation
        if (z<12) setStd(z, xx, Blue); // put z into the proper place for each position in quadrant 1
      }
      showKeep(20);
      fillTower(myhue);
    }
    myhue -= 3;
  }
  
  pause();
}

void threeRings1() {
  for (int count = 0; count < 18; count++) {
    for (int ring = 0; ring < 24; ring++) {
      int ring2, ring3, ring4;
      if (ring < 12) ring2 = ring;
      else ring2 = 23 - ring;
      if (ring > 7  && ring < 20) ring3 = ring - 8;
      if (ring < 9) ring3 = 8 - ring;
      if (ring > 19) ring3 = 31 - ring;
      if (ring > 15) ring4 = ring - 16;
      if (ring < 4) ring4 = ring + 8;
      if (ring > 3 && ring < 16) ring4 = 15 - ring;
      setRing(ring2, 0);
      if (count > 4) setRing(ring3, 167);
      if (count > 9) setRing(ring4, 83);
      showClear(15 + count * 4);
    }
  }
  pause();
}

void threeRings2() {
  int pos = 0;
  int dir = 1;
  for (int count = 0; count < 48; count++) {
    for (int j = 0; j < 12; j++) {
      for (int i = 0; i < 12; i++) {
        if (pgm_read_word_near(&plane[8][11 - j]) & (1 << i)) {
          setStd(j + 2, i, Red);
          setStd(j + 2, 23 - i, Red);
        }
      }
    }

    for (int i = 0; i < 23; i++) {
      for (int m = 0; m < 12; m++) {
        rotate(m, 0);
      }
      showKeep(5);
    }

    clearAll();
    setRing(pos, 83);
    setRing(11 - pos, 167);
    pos = pos + dir;
    if (pos == -1) {
      pos = 1;
      dir = +1;
    }
    if (pos == 12) {
      pos = 10;
      dir = -1;
    }
    showKeep(1);
  }
  pause();
}


void threeRings3() {
  wobble(1);
  wobble(2);
  wobble(3);
  pause();
}

void wobble(int pos) {
  if (pos == 1)myhue = 0;
  if (pos == 2)myhue = 167;
  if (pos == 3)myhue = 83;
  set2rings(pos);
  for (int k = 1; k < 10; k++) {
    for (int j = 0; j < 10; j++) {
      for (int i = 0; i < 12; i++) {
        if (pgm_read_word_near(&plane[k][11 - j]) & (1 << i)) {
          setHue(j + 2, i, myhue);
          setHue(j + 2, 23 - i, myhue);
        }
      }
    }
    for (int i = 0; i < 23; i++) {
      for (int m = 0; m < 12; m++) {
        rotate(m, 0);
      }
      showKeep(5 + k / 2);
    }
    clearAll();
    set2rings(pos);
  }
  for (int k = 8; k > 0; k--) {
    for (int j = 0; j < 10; j++) {
      for (int i = 0; i < 12; i++) {
        if (pgm_read_word_near(&plane[k][11 - j]) & (1 << i)) {
          setHue(j + 2, i, myhue);
          setHue(j + 2, 23 - i, myhue);
        }
      }
    }
    for (int i = 0; i < 23; i++) {
      for (int m = 0; m < 12; m++) {
        rotate(m, 0);
      }
      showKeep(5 + k / 2);
    }
    clearAll();
    set2rings(pos);
  }
}

void set2rings(int pos) {
  if (pos == 1) {
    setRing(1, 167);
    setRing(0, 83);
  }
  else if (pos == 2) {
    setRing(1, 83);
    setRing(0, 0);
  }
  else if (pos == 3) {
    setRing(1, 0);
    setRing(0, 167);
  }
}


void shiftingPlanes() {
  int mydelay = 5;
  for (int count = 0; count < 2; count++) {
    for (int k = 1; k < 9; k++) {
      for (int j = 0; j < 12; j++) {
        for (int i = 0; i < 12; i++) {
          if (pgm_read_word_near(&plane[k][11 - j]) & (1 << i)) {
            setHue(j, i, myhue);
            setHue(j, 23 - i, myhue);
          }
        }
      }
      for (int i = 0; i < 23; i++) {
        for (int m = 0; m < 12; m++) {
          rotate(m, 0); // clockwise
        }
        showKeep(mydelay);
      }
      clearAll();
      myhue += 3;
    }
    for (int k = 1; k < 4; k++) {
      for (int j = 0; j < 12; j++) {
        for (int i = 0; i < 12; i++) {
          if (pgm_read_word_near(&plane[8][11 - j]) & (1 << i)) {
            setHue(j + k, i, myhue);
            setHue(j + k, 23 - i, myhue);
          }
        }
      }
      for (int i = 0; i < 23; i++) {
        for (int m = 0; m < 12; m++) {
          rotate(m, 0); // clockwise
        }
        showKeep(mydelay);
      }
      if (k < 3)clearAll();
      myhue += 3;
    }
    for (int i = 0; i < 12; i++) {
      for (int m = 0; m < 12; m++) {
        rotate(m, 0); // clockwise
      }
      showKeep(mydelay);
    }
    clearAll();
    myhue += 3;
    for (int k = 7; k > 1; k--) {
      for (int j = 0; j < 12; j++) {
        for (int i = 0; i < 12; i++) {
          if (pgm_read_word_near(&plane[k][j]) & (1 << i)) {
            setHue(j, i, myhue);
            setHue(j, 23 - i, myhue);
          }
        }
      }
      for (int i = 0; i < 23; i++) {
        for (int m = 0; m < 12; m++) {
          rotate(m, 0); // clockwise
        }
        showKeep(mydelay);
      }
      clearAll();
      myhue += 3;
    }

    for (int k = 1; k < 8; k++) {
      for (int j = 0; j < 12; j++) {
        for (int i = 0; i < 12; i++) {
          if (pgm_read_word_near(&plane[k][j]) & (1 << i)) {
            setHue(j, i, myhue);
            setHue(j, 23 - i, myhue);
          }
        }
      }
      for (int i = 0; i < 23; i++) {
        for (int m = 0; m < 12; m++) {
          rotate(m, 0); // clockwise
        }
        showKeep(mydelay);
      }
      if (k < 7)clearAll();
      myhue += 3;
    }

    for (int i = 0; i < 12; i++) {
      for (int m = 0; m < 12; m++) {
        rotate(m, 0); // clockwise
      }
      showKeep(mydelay);
    }
    clearAll();
    myhue += 3;

    for (int k = 3; k > 0; k--) {
      for (int j = 0; j < 12; j++) {
        for (int i = 0; i < 12; i++) {
          if (pgm_read_word_near(&plane[8][11 - j]) & (1 << i)) {
            setHue(j + k, i, myhue);
            setHue(j + k, 23 - i, myhue);
          }
        }
      }
      for (int i = 0; i < 23; i++) {
        for (int m = 0; m < 12; m++) {
          rotate(m, 0); // clockwise
        }
        showKeep(mydelay);
      }
      clearAll();
      myhue += 3;
    }

    for (int k = 8; k > 1; k--) {
      for (int j = 0; j < 12; j++) {
        for (int i = 0; i < 12; i++) {
          if (pgm_read_word_near(&plane[k][11 - j]) & (1 << i)) {
            setHue(j, i, myhue);
            setHue(j, 23 - i, myhue);
          }
        }
      }
      for (int i = 0; i < 23; i++) {
        for (int m = 0; m < 12; m++) {
          rotate(m, 0); // clockwise
        }
        showKeep(mydelay);
      }
      clearAll();
      myhue += 3;
    }
  }
}

void planeFun() {
  for (int k = 1; k < 18; k++) {
    for (int j = 0; j < 12; j++) {
      for (int i = 0; i < 12; i++) {
        if (pgm_read_word_near(&plane[k][11 - j]) & (1 << i)) {
          setStd(j, i, Red);
          setStd(j, 23 - i, Red);
        }
      }
    }
    for (int i = 0; i < 23; i++) {
      for (int m = 0; m < 12; m++) {
        rotate(m, 0); // clockwise
      }
      showKeep(10 + k / 2);
    }
    clearAll();
  }
  myhue = 0;
  for (int k = 0; k < 5; k++) {
    myhue += 34;
    for (int j = 0; j < 12; j++) {
      for (int i = 0; i < 12; i++) {
        if (pgm_read_word_near(&plane[17][j]) & (1 << i)) {
          setHue(j, i, myhue);
          setHue(j, 23 - i, myhue);
        }
      }
    }
    for (int i = 0; i < 23; i++) {
      for (int m = 0; m < 12; m++) {
        rotate(m, 0); // clockwise
      }
      showKeep(18);
    }
    clearAll();
  }

  for (int k = 16; k > 0; k--) {
    for (int j = 0; j < 12; j++) {
      for (int i = 0; i < 12; i++) {
        if (pgm_read_word_near(&plane[k][j]) & (1 << i)) {
          setStd(j, i, Blue);
          setStd(j, 23 - i, Blue);
        }
      }
    }
    for (int i = 0; i < 23; i++) {
      for (int m = 0; m < 12; m++) {
        rotate(m, 0); // clockwise
      }
      showKeep(10 + k / 2);
    }
    clearAll();
  }

  for (int m = 11; m >= 1; m--) {
    for (int i = 0; i < 23; i++) {
      setHue(m, i, 167 + 4 * (11 - m));
    }
    showClear(75);
  }
  for (int m = 0; m < 12; m++) {
    for (int i = 0; i < 23; i++) {
      setHue(m, i, 211 + 4 * m);
    }
    showClear(75);
  }
  brightness(45);
  myhue = 0;
  for (int rot = 0; rot < 12; rot++) {
    for (int k = 1; k < 18; k++) {
      for (int j = 0; j < 12; j++) {
        for (int i = 0; i < 12; i++) {
          if (pgm_read_word_near(&plane[k][11 - j]) & (1 << i)) {
            setHue(11 - j, i, myhue);
            setHue(11 - j, 23 - i, myhue);
          }
        }
      }
      for (int i = 0; i < rot; i++) {
        for (int m = 0; m < 12; m++) {
          rotate(m, 0); // clockwise
        }
      }
      showClear(5);
      if (k % 2) myhue++;
    }

    for (int k = 17; k > -1; k--) {
      for (int j = 0; j < 12; j++) {
        for (int i = 0; i < 12; i++) {
          if (pgm_read_word_near(&plane[k][11 - j]) & (1 << i)) {
            setHue(11 - j, 11 - i, myhue);
            setHue(11 - j, 12 + i, myhue);
          }
        }
      }
      for (int i = 0; i < rot; i++) {
        for (int m = 0; m < 12; m++) {
          rotate(m, 0); // clockwise
        }
      }
      showClear(5);
      if (k % 2) myhue++;
    }

  }
  brightness(25);
  for (int m = 11; m >= 1; m--) {
    for (int i = 0; i < 23; i++) {
      setHue(m, i, 167 + 7 * (11 - m));
    }
    showClear(75);
  }
  pause();
}


void towerDrop() {
  for (int i = 0; i < 300; i++) {
    myhue += 2;
    int myran = random(24);
    int myran2 = random(24);
    setHue(11, myran, myhue);
    setHue(11, myran2, random(255));
    showKeep(100);
    copyDown();
    if ((i < 50) || (i > 250)) {
      setStd(11, myran, Black);
      setStd(11, myran2, Black);
    }
  }
  pause();
}



void wireframe() {
  byte k1, k2, k3;
  for (int k = 0; k < 300; k++) {
    myhue += 5;
    k1 = k % 24;
    k2 = k % 24 + 8; if (k2 > 23) k2 = k2 - 24;
    k3 = k % 24 + 16; if (k3 > 23) k3 = k3 - 24;
    setRing(11, myhue);
    setRing(0, myhue);
    setCol(k1, myhue);
    setCol(k2, myhue);
    setCol(k3, myhue);
    setStd(11, k1, Black);
    setStd(11, k2, Black);
    setStd(11, k3, Black);
    setStd(0, k1, Black);
    setStd(0, k2, Black);
    setStd(0, k3, Black);
    for (int j = 0; j < 12; j++) {
      rotate(j, 0); // clockwise
    }
    showKeep(75);
  }
  pause();
}

void towerFades() {
  for (int j = 0; j < 300; j++) {
    myhue++;
    if (myhue % 2 == 0)setRing(random(12), 21 * random(12));
    setCol(random(24), 21 * random(12));
    showKeep(100);
    fadeAll(150);
  }
  pause();
}

void rotatingOval() {
  byte myHue = 0;
  int o = 0; // offset
  for (int i = 0; i < 30; i++) {
    if (i < 9)o = i;
    if (i > 8 && i < 24) o = 16 - i;
    if (i > 23) o = i - 30;
    if (o + 8 < 12)setHue(o + 8, 0, myHue);
    if (o + 8 < 12)setHue(o + 8, 1, myHue);
    if (o + 7 < 12)setHue(o + 7, 2, myHue);
    if (o + 7 < 12)setHue(o + 7, 3, myHue);
    if (o + 6 < 12)setHue(o + 6, 4, myHue);
    if (o + 5 < 12)setHue(o + 5, 5, myHue);
    if (o + 5 < 12)setHue(o + 5, 6, myHue);
    if (o + 4 < 12)setHue(o + 4, 7, myHue);
    if (o + 3 > -1)setHue(o + 3, 8, myHue);
    if (o + 3 > -1)setHue(o + 3, 9, myHue);
    if (o + 2 > -1)setHue(o + 2, 10, myHue);
    if (o + 2 > -1)setHue(o + 2, 11, myHue);

    if (o + 2 > -1)setHue(o + 2, 12, myHue);
    if (o + 2 > -1)setHue(o + 2, 13, myHue);
    if (o + 3 > -1)setHue(o + 3, 14, myHue);
    if (o + 3 > -1)setHue(o + 3, 15, myHue);
    if (o + 4 < 12)setHue(o + 4, 16, myHue);
    if (o + 5 < 12)setHue(o + 5, 17, myHue);
    if (o + 5 < 12)setHue(o + 5, 18, myHue);
    if (o + 6 < 12)setHue(o + 6, 19, myHue);
    if (o + 7 < 12)setHue(o + 7, 20, myHue);
    if (o + 7 < 12)setHue(o + 7, 21, myHue);
    if (o + 8 < 12)setHue(o + 8, 22, myHue);
    if (o + 8 < 12)setHue(o + 8, 23, myHue);
    for (int k = 0; k < 23; k++) {
      for (int j = 0; j < 12; j++) {
        rotate(j, 1); // clockwise
      }
      showKeep(12);
    }
    myHue += 9;
    clearAll();
  }
  pause();
}

void upDownRings() {
  for (int i = 0; i < 20; i++) {
    for (int j = 0; j < 12; j++) {
      for (int k = 0; k < 24; k++) {
        setStd(j, k, Blue);
      }
      showClear(40);
    }
    for (int j = 10; j > 0; j--) {
      for (int k = 0; k < 24; k++) {
        setStd(j, k, Blue);
      }
      showClear(40);
    }
  }
  pause();
}

void rotatingReds() {
  setStd(0, 0, Red);
  setStd(1, 0, Red);
  setStd(2, 0, Red);
  setStd(3, 0, Red);
  setStd(4, 0, Red);
  setStd(5, 0, Red);
  setStd(6, 0, Red);
  setStd(7, 0, Red);
  setStd(8, 0, Red);
  setStd(9, 0, Red);
  setStd(10, 0, Red);
  setStd(11, 0, Red);
  showKeep(1);
  for (int k = 400; k < 800; k++) {
    for (int j = 0; j < 12; j++) {
      if (j % 2)rotate(j, 1); // clockwise
      else rotate(j, 0);
    }
    showKeep(110 - (k >> 3));
  }
  pause();
}

// this is a spiral exceeding 1 full revolution so
// couldn't be done with sprial routine
void bigSpiral() {
  setStd(0, 0, Green);
  setStd(1, 3, Green);
  setStd(2, 6, Green);
  setStd(3, 9, Green);
  setStd(4, 12, Green);
  setStd(5, 15, Green);
  setStd(6, 18, Green);
  setStd(7, 21, Green);
  setStd(8, 0, Green);
  setStd(9, 3, Green);
  setStd(10, 6, Green);
  setStd(11, 9, Green);
  showKeep(1);
  for (int k = 0; k < 300; k++) {
    for (int j = 0; j < 12; j++) {
      rotate(j, 0); // clockwise
    }
    showKeep(25);
  }
  pause();
}


// Rings rotate in opposite directions and fade
void doubleFade() {
  for (int i = 0; i < 15; i++) {
    for (int k = 0; k < 24; k++) {
      for (int j = 0; j < 12; j++) {
        if (j % 2)setStd(j, k, Green);
        else setStd(j, 23 - k, Blue);
      }
      showKeep(50);
      fadeAll(150);
    }
  }
  pause();
}


// spiral demo
// parameters: degree of spiral, color, # of rotations, delay, dir of rotation, dir of spiral
// works up to one full revolution; e.g degree 7 with 7 rings int(49/2)=24; 4 with 12 rings (4*12)/2=24
void spiralDemo() {
  spiral(1, Yellow, 5, 25, 0, 1);
  spiral(2, Green, 5, 25, 0, 0);
  spiral(3, Aqua, 5, 25, 0, 1);
  spiral(4, Red, 5, 25, 0, 0);
  spiral(4, Blue, 5, 75, 1, 1);
}
